import React, { cloneElement } from 'react';
import { TextInput, UIManager, requireNativeComponent } from 'react-native';
import PropTypes from 'prop-types';

export default class extends TextInput {
  static displayName = 'MarkedRangeTextInput';

  static propTypes = {
    ...TextInput.propTypes,
    shouldReturn: PropTypes.bool,
    focusable: PropTypes.bool
  };

  static defaultProps = {
    shouldReturn: true,
    focusable: true
  }

  render() {
    const wrapper = super.render();
    const textInput = wrapper.props.children;
    const props = {
      ...textInput.props,
      ref: this._setNativeRef
    };

    return cloneElement(wrapper, wrapper.props, <RNTextInput {...props} />);
  }
}

const RNTextInput = requireNativeComponent('RNTextInput', null);
